package ema.tpjee.banking.controlerv0;

import java.io.IOException;
import java.util.Collection;
import java.util.Enumeration;
import java.util.Iterator;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import ema.tpjee.banking.dao.BankDao;
import ema.tpjee.banking.dao.BankDaoImpl;
import ema.tpjee.banking.model.Bank;
import ema.tpjee.utils.ServletUtils;

/**
 * Servlet implementation class for Servlet: BankingControler
 * 
 */
public class BankControler extends javax.servlet.http.HttpServlet implements
		javax.servlet.Servlet {
	static final long serialVersionUID = 1L;

	private BankDao bankDao;

	/**
	 * Constructeur Le DAO est stateless, il peut donc tre li  la servlet
	 * (pas de pb d'accs concurrent)
	 */
	public BankControler() {
		super();
		System.out.println("creating BankControler");
		bankDao = new BankDaoImpl();
	}



	protected void doGet(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {

		request.getSession().setAttribute("controler-class",
				this.getClass().getName());
		ServletUtils.debugRequestParameters(this.getClass(), request);
		ServletUtils.debugSessionAttributes(this.getClass(), request);

		String page = request.getParameter("page");
		String cmd = request.getParameter("cmd");

		System.out.println("cmd = " + cmd);

		String fw = "/";
		int id = 0;
		try {
			id = Integer.parseInt(request.getParameter("id"));
		} catch (Exception e) {

		}

		Bank bean = bankDao.find(id);
	
		if ("editer".equals(cmd) || cmd == null)
			fw = "/pages/" + page + ".jsp";
		else {
			// request.getSession().removeAttribute("currentbank");
			System.out.println("commande inconnue");
		}
		request.getSession().setAttribute("currentbank", bean);
		request.getSession().setAttribute("banks", bankDao.getList());
		System.out.println("forwarding to: " + fw);
		getServletContext().getRequestDispatcher(fw).forward(request, response);
	}

	/*
	 * (non-Java-doc)
	 * 
	 * @see javax.servlet.http.HttpServlet#doPost(HttpServletRequest request,
	 *      HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {
		doGet(request, response);
	}

	@Override
	public void init() throws ServletException {
		bankDao.populate();
		super.init();
	}
}