package ema.tpjee.banking.controlerv1;

import java.io.IOException;
import java.util.Enumeration;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import ema.tpjee.banking.dao.BankDaoImpl;
import ema.tpjee.banking.dao.CustomerDaoImpl;
import ema.tpjee.banking.model.Bank;
import ema.tpjee.banking.model.Customer;
import ema.tpjee.utils.ServletUtils;

/**
 * Servlet implementation class for Servlet: ClientControler
 * 
 */
public class ClientControler extends javax.servlet.http.HttpServlet implements
		javax.servlet.Servlet {
	static final long serialVersionUID = 1L;

	private CustomerDaoImpl customerDao;

	/*
	 * (non-Java-doc)
	 * 
	 * @see javax.servlet.http.HttpServlet#HttpServlet()
	 */
	public ClientControler() {
		super();
		System.out.println("creating ClientControler");
		customerDao = new CustomerDaoImpl();

	}

	private void populate(HttpServletRequest request,Bank currentb){
		if (request.getSession().getAttribute("initcustomer") == null) {
			request.getSession().setAttribute("initcustomer", "done");
			customerDao.populate(currentb);
		}	
	}
	
	

	
	/*
	 * (non-Java-doc)
	 * 
	 * @see javax.servlet.http.HttpServlet#doGet(HttpServletRequest request,
	 *      HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {
		request.getSession().setAttribute("controler-class", this.getClass().getName());
		ServletUtils.debugRequestParameters(this.getClass(),request);
		ServletUtils.debugSessionAttributes(this.getClass(),request); 
		String cmd = request.getParameter("cmd");
		System.out.println("cmd = " + cmd);
		
		Bank currentb = (Bank) request.getSession().getAttribute("currentbank");
		populate(request,currentb);
	
		String fw = "/pages/client.jsp";
		if (currentb != null) {
			List<Customer> custs = customerDao.getList(currentb);
			request.getSession().setAttribute("customers", custs);
			if (custs.size()>0){
				request.getSession().setAttribute("currentcustomer", custs.get(0));
			}
		}
		System.out.println("forwarding to: "+fw);
		getServletContext().getRequestDispatcher(fw).forward(request, response);
	}

	/*
	 * (non-Java-doc)
	 * 
	 * @see javax.servlet.http.HttpServlet#doPost(HttpServletRequest request,
	 *      HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {
		doGet(request, response);
	}
}